/*
 * LoSTServerInterface.js
 * Yipeng Huang yh2315@columbia.edu
 * Columbia University
 * Module that handles the AJAX query with the LoST server.
 * This enables the client to conduct cross-domain AJAX queries.
 */

function sendQueryAJAX(proxy_url, lost_url, lost_query, lost_query_success_callback, lost_query_error_callback) {

    var callbackParams = {};
    callbackParams.exception;
    callbackParams.responseText;
    callbackParams.status;
    callbackParams.statusText;

    var client;
    var querystring = proxy_url + "?lost_url=" + lost_url + "&lost_query=" + encodeURIComponent(lost_query);

    //AJAX code
    if (window.XMLHttpRequest) {
        // code for IE7+, Firefox, Chrome, Opera, Safari
        client = new XMLHttpRequest();
    }
    else if (window.ActiveXObject) {
        // code for IE6, IE5
        client = new ActiveXObject("Microsoft.XMLHTTP");
    }
    else {
        debug("Your browser does not support XMLHttpRequest");
    }

    client.open("GET", querystring, true);
    //non-blocking query
    client.send(null);

    //listen to the query response
    client.onreadystatechange = function() {
        if (client.readyState == 4) {

            alert("client.readyState = " + client.readyState + " client.status = " + client.status + " client.responseText = " + client.responseText);

            if (client.status == 200) {
	
                var jsonParser = xml2json.parser(client.responseText);

                // REDIRECT LOGIC
                if (typeof jsonParser.redirect !== "undefined") {
                    // Put client response text into exception
                    callbackParams.exception = "LoST REDIRECT: " + client.responseText;
                    sendQueryAJAX(PROXY_URL, jsonParser.redirect.target, pub.lostQueryString, lost_query_success_callback, lost_query_error_callback);
					//call error call back to send exception message, recursed query continues.
                    lost_query_error_callback(callbackParams);
                }
                else if (typeof jsonParser.errors !== "undefined") {
                    // Put client response text into exception
                    callbackParams.exception = "LoST EXCEPTION: " + client.responseText;
                    lost_query_error_callback(callbackParams);
                }
                else {
                    //succcess
                    callbackParams.responseText = client.responseText;
                    lost_query_success_callback(callbackParams);
                }
            }
            else {
                // alert("ERROR: LoST query failed " + client.status + " " + client.statusText);
                callbackParams.exception = "HTTP EXCEPTION: " + client.status + " " + client.statusText;
                lost_query_error_callback(callbackParams);
            }
        }
    }
}